\section{Design Patterns}

%todo add week 01

\subsection{Factory Method}
Define an interface for creating an object, but let subclasses decide which class to instantiate. Factory Method lets a class defer instantiation to subclasses.  Factory Methods can be abstract or virtual. When it is virtual think about Null Objects, also called hooks when virtual. A Factory Method is typically called from within a template method. Name should start with the Create-prefix. It is a very useful tool for testing legacy code. 

\begin{figure}[h!]
  \center
  \includegraphics[width=0.5\textwidth]{factorymethod}
  \caption{Dice Game without Factory Method}
\end{figure}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{dicegame}
  \caption{Dice Game Factory Method}
\end{figure}

\subsection{Abstract Factory}
Is a factory method with the help of inheritance. According to FCol, composition should be favoured over inheritance. Object creation is a responsibility – which can justify a separate class (SRP). To satisfy both principles, move the object creation to a class called Factory and inject an object of that factory into game.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{abstractfactory}
  \caption{Abstract Factory}
\end{figure}

\subsection{Singleton}
The Singleton is the simples GoF-pattern of al - as a result, it is often taught first. This patters has some serious drawbacks and should be avoided.  Even Erich Gamma said that it should not have been in the book. Ensure a class only has one instance, and provide a global point of access to it.

Drawbacks
\begin{itemize}
	\item Singletons are globals with high coupling
	\item Singletons are hard to test
	\item Singletons are error-prone when multi-threading 
\end{itemize}

When you need a single instance, either
\begin{itemize}
	\item create it in your main() and inject it
	\item lett a factory or proxy manage its lifecycle
	\item use an IoC-Container to manage its lifecycle
\end{itemize}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{singleton}
  \caption{Singleton}
\end{figure}

\subsection{Adapter}
An Adapter transforms an interface into one a client expects. Adapter can add functionality to Adaptee. Necessary work mainly depends on the size and complexity of the target interface.  If creating the Adaptee is complex, think about injection or Factories.
 
\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{adapter}
  \caption{Adapter}
\end{figure}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{adaptercode}
  \caption{Adapter}
\end{figure}

\subsection{Facade}
A Facade decouples a client from a complex, internal or external subsystem. Try to keep the interface of the Facade small. Multiple Facades for the same subsystem are possible (SRP). Important tool of Software Architects for achieving exchangeability.   

\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{facade}
  \caption{Facade}
\end{figure}

\subsection{Composite}
Composite is a trade-off between SRP and transparency.  Like in the example, it is possible to define Add and Remove only on the Composite. Clients should avoid casting elements of a Composite to a concrete type.

Possible variations
\begin{itemize}
	\item Component as interface or abstract class
	\item Component with abstract or virtual methods
	\item Children having references to their parents
\end{itemize}   

\begin{figure}[h!]
  \center
  \includegraphics[width=\textwidth]{composite}
  \caption{Composite}
\end{figure}

\subsection{Decorator}
Provides an alternative to subclassing for extending behavior. Added behavior can be called before and/or after method calls to the component. Decorators are invisible to the client.  Decorator and Composite are similar, but have different uses. Decorator is used to add behavior, Composite is used to model tree-like structures. Decorator lets you change the skin of an object, Strategy lets you change the guts

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{decorator}
  \caption{Decorator}
\end{figure}

\subsection{Proxy}
There are different variations of the proxy. Proxy and Decorator are similar in structure, but have different intents.


\begin{itemize}
	\item Virtual Proxy - controls access to an object that is expensive to instantiate.
	\item Remote Proxy - manages interaction between a client and a remote object. 
	\item Protection Proxy - controls access to the original object. 
	\item Caching Proxy - keeps track of calculated values for better performance. 
\end{itemize}
For transparency, Proxy and RealSubject are often created within a Factory.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.5\textwidth]{proxy}
  \caption{Proxy UML}
\end{figure}


\begin{figure}[h!]
  \center
  \includegraphics[width=0.8\textwidth]{proxy}
  \caption{Proxy}
\end{figure}

\subsection{}


